% % Add user-defined preamble here.
% % Example: listing style or acronyms

%\lstdefinestyle{numbers}{
%	numbers=right,
%	stepnumber=1,
%	numberstyle=\tiny\color{magenta},
%	numbersep=-7pt
%}


\begin{acronym}
	\acro{abac}[ABAC]{Attribute Based Access Control}
	\acro{abacee}[AbacEE]{ABAC Expression Evaluator}
	\acro{acp}[ACP]{Attribute Caching Point}
	\acro{adp}[ADP]{Administration and Delegation Profile}
	\acro{alfa}[ALFA]{Abbreviated Language For Authorisation}
	\acro{am}[AM]{Attribute Manager}
	\acro{ar}[AR]{Attribute Retriever}
	\acro{at}[AT]{Attribute Table}
	\acro{capbac}[CapBAC]{Capability-Based Access Control}
	\acro{can}[CAN]{Controller Area Network}
	\acro{ch}[CH]{Context Handler}
	\acro{ciso}[CISO]{Chief Information Security Officer}
	\acro{compac}[CoMPAC]{Continuous MultiPhasic Access Contol}
	\acro{dac}[DAC]{Discretionary Access Control}
	\acro{dfa}[DFA]{Deterministic Finite Automaton}
	\acro{dht}[Distributed Hash Table]{DHT}
	\acro{dm}[DM]{Directives Manager}
	\acro{drl}[DRL]{Drools Rule Language}
	\acro{drm}[DRM]{Digital Rights Management}
	\acro{ds}[DS]{Data Subject}
	\acro{ecu}[ECU]{Electronic Control Unit}
	\acro{essif}[ESSIF]{European Self Sovereign Identity Framework}
	\acro{fim}[FIM]{Federated Identity Management}
	\acro{fsm}[FSM]{Finite State Machine}
	\acro{gdpr}[GDPR]{General Data Protection Regulation}
	\acro{gw}[GW]{Gateway}
	\acro{ifttt}[IFTTT]{IF This Then That}
	\acro{iam}[IAM]{Identity and Access Management}
	\acro{idp}[IdP]{Identity Provider}
	\acro{idsa}[IDSA]{International Data Spaces Association}
	\acro{ioe}[IoE]{Internet of Everything}
	\acro{iot}[IoT]{Internet of Things}
	\acro{iov}[IoV]{Internet of Vehicles}
	\acro{ipr}[IPR]{Intellectual Property Rights}
	\acro{json}[JSON]{JavaScript Object Notation}
	\acro{jws}[JWS]{JSON Web Signatures}
	\acro{jwt}[JWT]{JSON Web Token}
	\acro{lbac}[LBAC]{Lattice Based Access Control}
	\acro{ldp}[LDP]{Lifecycle Decision Point}
	\acro{mac}[MAC]{Mandatory Access Control}
	\acro{mfa}[MFA]{Multi-Factor Authentication}
	\acro{msgbus}[MSG BUS]{Message Bus}
	\acro{obd2}[OBD-II]{On-Board Diagnostics-II}
	\acro{oem}[OEM]{Original Equipment Manufacturer}
	\acro{om}[OM]{Obligation Manager}
	\acro{oidc}[OIDC]{OpenID Connect}
	\acro{pap}[PAP]{Policy Administration Point}
	\acro{pdp}[PDP]{Policy Decision Point}
	\acro{pep}[PEP]{Policy Enforcement Point}
	\acro{pip}[PIP]{Policy Information Point}
	\acro{pmp}[PMP]{Policy Monitoring and Mapping Point}
	\acro{poc}[PoC]{Proof-of-Concept}
	\acro{polp}[PoLP]{Principle of Least Privilege}
	\acro{pubsub}[Pub/Sub]{Publish/Subscribe}
	\acro{rbac}[RBAC]{Role Based Access Control}
	\acro{rebac}[ReBAC]{Relationship Based Access Control}
	\acro{srp}[SRP]{Session Retention Point}
	\acro{siuv}[SIUV]{Smart-car Identity management and Usage control system based on Verifiable credentials}
	\acro{sm}[SM]{Session Manager}
	\acro{soa}[SOA]{Service-Oriented Architecture}
	\acro{ssi}[SSI]{Self-Sovereign Identity}
	\acrodefplural{ssi}[SSIs]{Self-Sovereign Identities}
	\acro{sts}[STS]{Security Token Service}
	\acro{tlee}[TLEE]{Trust Level Evaluation Engine}
	\acro{tm}[TM]{Trust Management}
	\acro{ucon}[UCON]{Usage Control}
	\acro{ucs}[UCS]{Usage Control System}
	\acro{ucsp}[UCS+]{Usage Control System Plus}
	\acrodefplural{ucsp}[UCS+ nodes]{Usage Control System Plus nodes}
	\acro{vc}[VC]{Verifiable Credential}
	\acro{vdr}[VDR]{Verifiable Data Registry}
	\acro{wfms}[WfMS]{Workflow Management System}
	\acro{xacml}[XACML]{eXtensible Access Control Markup Language}
	\acro{zta}[ZTA]{Zero-Trust Architecture}
	\acro{ztn}[ZTN]{Zero-Trust Networks}
\end{acronym}

\lstdefinestyle{numbers}{
	numbers=right,
	stepnumber=1,
	numberstyle=\tiny\color{magenta},
	numbersep=-7pt
}

\lstdefinestyle{MyFrame}{
	basicstyle={\scriptsize},
	backgroundcolor=\color{gray!10},
	xleftmargin=0.5em,
	xrightmargin=0.5em,
	framexrightmargin=0.5em,
	frame=shadowbox,
	frame=single,
	breaklines=true,
	linewidth=\linewidth,
	postbreak=\raisebox{0ex}[0ex][0ex]{\ensuremath{\color{blue}\hookrightarrow\space}},
	columns=fullflexible,
	captionpos=t,
	tabsize=4,
	showstringspaces=false,
	breakatwhitespace=false,
}

\lstset{
	style=numbers,
	style=MyFrame,
	escapechar={|},
	stringstyle=\color{gray},
	identifierstyle=\color{black},
	keywordstyle=\color{blue},
	upquote=true,
	morekeywords={policy, target, clause, rule, condition, on, permit, obligation, Attributes, in, If, Else, Then},
}

\colorlet{punct}{red!60!black}
\definecolor{background}{HTML}{EEEEEE}
\definecolor{delim}{RGB}{20,105,176}
\colorlet{numb}{magenta!60!black}

\lstdefinelanguage{json}{
	numbers=right,
	stepnumber=1,
	numbersep=0pt,
	showstringspaces=false,
	breaklines=true,
	frame=single,
	framexrightmargin=0.5em,
	upquote=true,
	keywordstyle=\color{blue},
	morekeywords={@context, credentialSubject, id, issuanceDate, issuer, type},
	literate=
	{:}{{{\color{punct}{:}}}}{1}
	{,}{{{\color{punct}{,}}}}{1}
	{\{}{{{\color{delim}{\{}}}}{1}
	{\}}{{{\color{delim}{\}}}}}{1}
	{[}{{{\color{delim}{[}}}}{1}
	{]}{{{\color{delim}{]}}}}{1},
}